# OTVideoFrame Class Reference

Inherits from | NSObject
Declared in | OTVideoKit.h

## Overview

Defines a frame of a video. See [OTVideoRender renderVideoFrame:] and [OTVideoCaptureConsumer consumeFrame:].

## Properties of OTVideoFrame objects

### `planes`

An array of planes in the video frame.

`@property (nonatomic, strong) NSPointerArray *planes`

#### Declared In

`OTVideoKit.h`

### `timestamp`

A timestap of the video frame.

`@property (nonatomic, assign) CMTime timestamp`

#### Declared In

`OTVideoKit.h`

### `orientation`

The orientation of the video frame.

`@property (nonatomic, assign) OTVideoOrientation orientation`

#### Declared In

`OTVideoKit.h`

### `format`

The format of the video frame.

`@property (nonatomic, strong) OTVideoFormat *format`

#### Declared In

`OTVideoKit.h`

### `metadata`

The metadata associated with this video frame, if any. (Deprecated: This property is deprecated and will be removed in a future version of the library.)

`@property (nonatomic, readonly) NSData *metadata`

#### Declared In

`OTVideoKit.h`

## Instantiating OTVideoFrame objects

### `– init`

Initializes an OTVideoFrame object.

`- (nonnull id)init`

#### Declared In

`OTVideoKit.h`

### `– initWithFormat:`

Initializes an OTVideoFrame object with a specified format.

`- (nonnull id)initWithFormat:(nonnull OTVideoFormat *)videoFormat`

#### Parameters

`videoFormat` | The video format used by the video frame.

#### Declared In

`OTVideoKit.h`

### `– setPlanesWithPointers:numPlanes:`

Sets planes for the video frame.

`- (void)setPlanesWithPointers:(uint8_t *_Nonnull [ _Nonnull ])planes numPlanes:(int)numPlanes`

#### Parameters

`planes` | The planes to assign.
`numPlanes` | The number of planes to assign.

#### Declared In

`OTVideoKit.h`

### `– clearPlanes`

Cleans the planes in the video frame.

`- (void)clearPlanes`

#### Declared In

`OTVideoKit.h`

### `– convertInPlace:planes:strides:`

Converts video frame without allocating new planes.

`- (void)convertInPlace:(OTPixelFormat)pixelFormat planes:(uint8_t *_Nonnull *_Nonnull)planes strides:(int *_Nonnull)strides`

#### Declared In

`OTVideoKit.h`

### `– getPlaneBinaryData:`

Gets the binary data for the individual video frame.

`- (uint8_t *_Nonnull)getPlaneBinaryData:(int)plane`

#### Parameters

`plane` | The planes to assign.

#### Declared In

`OTVideoKit.h`

### `– getPlaneStride:`

Gets the stride value for the plane

`- (int)getPlaneStride:(int)plane`

#### Parameters

`plane` | The planes to assign.

#### Declared In

`OTVideoKit.h`